Bullet Collision Detection & Physics Library: btDeformableContactProjection Class Reference

Bullet Collision Detection & Physics Library

Public Types | Public Member Functions | Public Attributes | List of all members
btDeformableContactProjection Class Reference

`#include <btDeformableContactProjection.h>`

Collaboration diagram for btDeformableContactProjection:
[legend]

## Public Types
typedef btAlignedObjectArray< btVector3 > | TVStack

## Public Member Functions
| btDeformableContactProjection (btAlignedObjectArray< btSoftBody * > &softBodies)
virtual | ~btDeformableContactProjection ()
virtual void | project (TVStack &x)
virtual void | applyDynamicFriction (TVStack &f)
virtual btScalar | update (btCollisionObject **deformableBodies, int numDeformableBodies, const btContactSolverInfo &infoGlobal)
virtual void | setConstraints (const btContactSolverInfo &infoGlobal)
virtual void | setProjection ()
virtual void | reinitialize (bool nodeUpdated)
btScalar | solveSplitImpulse (btCollisionObject **deformableBodies, int numDeformableBodies, const btContactSolverInfo &infoGlobal)
virtual void | setLagrangeMultiplier ()
void | checkConstraints (const TVStack &x)

## Public Attributes
btAlignedObjectArray< btSoftBody * > & | m_softBodies
btAlignedObjectArray< btDeformableContactConstraint * > | m_allFaceConstraints
btHashMap< btHashInt, btAlignedObjectArray< btVector3 > > | m_projectionsDict
btAlignedObjectArray< LagrangeMultiplier > | m_lagrangeMultipliers
btAlignedObjectArray< btAlignedObjectArray< btDeformableStaticConstraint > > | m_staticConstraints
btAlignedObjectArray< btAlignedObjectArray< btDeformableNodeRigidContactConstraint > > | m_nodeRigidConstraints
btAlignedObjectArray< btAlignedObjectArray< btDeformableFaceRigidContactConstraint > > | m_faceRigidConstraints
btAlignedObjectArray< btAlignedObjectArray< btDeformableFaceNodeContactConstraint > > | m_deformableConstraints
btAlignedObjectArray< btAlignedObjectArray< btDeformableNodeAnchorConstraint > > | m_nodeAnchorConstraints
bool | m_useStrainLimiting

## Detailed Description

Definition at line 37 of file btDeformableContactProjection.h.

## Member Typedef Documentation

## ◆ TVStack

typedef btAlignedObjectArray<btVector3> btDeformableContactProjection::TVStack

Definition at line 40 of file btDeformableContactProjection.h.

## Constructor & Destructor Documentation

## ◆ btDeformableContactProjection()

btDeformableContactProjection::btDeformableContactProjection | ( | btAlignedObjectArray< btSoftBody * > & | softBodies | ) |
| inline

Definition at line 67 of file btDeformableContactProjection.h.

## ◆ ~btDeformableContactProjection()

virtual btDeformableContactProjection::~btDeformableContactProjection | ( |  | ) |
| inlinevirtual

Definition at line 72 of file btDeformableContactProjection.h.

## Member Function Documentation

## ◆ applyDynamicFriction()

void btDeformableContactProjection::applyDynamicFriction | ( | TVStack & | f | ) |
| virtual

Definition at line 563 of file btDeformableContactProjection.cpp.

## ◆ checkConstraints()

void btDeformableContactProjection::checkConstraints | ( | const TVStack & | x | ) |

Definition at line 442 of file btDeformableContactProjection.cpp.

## ◆ project()

void btDeformableContactProjection::project | ( | TVStack & | x | ) |
| virtual

Definition at line 153 of file btDeformableContactProjection.cpp.

## ◆ reinitialize()

void btDeformableContactProjection::reinitialize | ( | bool | nodeUpdated | ) |
| virtual

Definition at line 614 of file btDeformableContactProjection.cpp.

## ◆ setConstraints()

void btDeformableContactProjection::setConstraints | ( | const btContactSolverInfo & | infoGlobal | ) |
| virtual

Definition at line 90 of file btDeformableContactProjection.cpp.

## ◆ setLagrangeMultiplier()

void btDeformableContactProjection::setLagrangeMultiplier | ( |  | ) |
| virtual

Definition at line 460 of file btDeformableContactProjection.cpp.

## ◆ setProjection()

void btDeformableContactProjection::setProjection | ( |  | ) |
| virtual

Definition at line 202 of file btDeformableContactProjection.cpp.

## ◆ solveSplitImpulse()

btScalar btDeformableContactProjection::solveSplitImpulse | ( | btCollisionObject ** | deformableBodies,
|  | int | numDeformableBodies,
|  | const btContactSolverInfo & | infoGlobal
| ) |  |

Definition at line 61 of file btDeformableContactProjection.cpp.

## ◆ update()

btScalar btDeformableContactProjection::update | ( | btCollisionObject ** | deformableBodies,
|  | int | numDeformableBodies,
|  | const btContactSolverInfo & | infoGlobal
| ) |  |
| virtual

Definition at line 20 of file btDeformableContactProjection.cpp.

## Member Data Documentation

## ◆ m_allFaceConstraints

btAlignedObjectArray<btDeformableContactConstraint*> btDeformableContactProjection::m_allFaceConstraints

Definition at line 44 of file btDeformableContactProjection.h.

## ◆ m_deformableConstraints

btAlignedObjectArray<btAlignedObjectArray<btDeformableFaceNodeContactConstraint> > btDeformableContactProjection::m_deformableConstraints

Definition at line 61 of file btDeformableContactProjection.h.

## ◆ m_faceRigidConstraints

btAlignedObjectArray<btAlignedObjectArray<btDeformableFaceRigidContactConstraint> > btDeformableContactProjection::m_faceRigidConstraints

Definition at line 59 of file btDeformableContactProjection.h.

## ◆ m_lagrangeMultipliers

btAlignedObjectArray<LagrangeMultiplier> btDeformableContactProjection::m_lagrangeMultipliers

Definition at line 52 of file btDeformableContactProjection.h.

## ◆ m_nodeAnchorConstraints

btAlignedObjectArray<btAlignedObjectArray<btDeformableNodeAnchorConstraint> > btDeformableContactProjection::m_nodeAnchorConstraints

Definition at line 63 of file btDeformableContactProjection.h.

## ◆ m_nodeRigidConstraints

btAlignedObjectArray<btAlignedObjectArray<btDeformableNodeRigidContactConstraint> > btDeformableContactProjection::m_nodeRigidConstraints

Definition at line 57 of file btDeformableContactProjection.h.

## ◆ m_projectionsDict

btHashMap<btHashInt, btAlignedObjectArray<btVector3> > btDeformableContactProjection::m_projectionsDict

Definition at line 47 of file btDeformableContactProjection.h.

## ◆ m_softBodies

btAlignedObjectArray<btSoftBody*>& btDeformableContactProjection::m_softBodies

Definition at line 41 of file btDeformableContactProjection.h.

## ◆ m_staticConstraints

btAlignedObjectArray<btAlignedObjectArray<btDeformableStaticConstraint> > btDeformableContactProjection::m_staticConstraints

Definition at line 55 of file btDeformableContactProjection.h.

## ◆ m_useStrainLimiting

bool btDeformableContactProjection::m_useStrainLimiting

Definition at line 65 of file btDeformableContactProjection.h.

The documentation for this class was generated from the following files:

- btDeformableContactProjection.h
- btDeformableContactProjection.cpp